zoukankan      html  css  js  c++  java
  • hdu 4442 Physical Examination 贪心排序

    Physical Examination

    Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
    Total Submission(s): 6155 Accepted Submission(s): 1754

    Problem Description

    WANGPENG is a freshman. He is requested to have a physical examination when entering the university.
    Now WANGPENG arrives at the hospital. Er….. There are so many students, and the number is increasing!
    There are many examination subjects to do, and there is a queue for every subject. The queues are getting longer as time goes by. Choosing the queue to stand is always a problem. Please help WANGPENG to determine an exam sequence, so that he can finish all the physical examination subjects as early as possible.

    Input

    There are several test cases. Each test case starts with a positive integer n in a line, meaning the number of subjects(queues).
    Then n lines follow. The i-th line has a pair of integers (ai, bi) to describe the i-th queue:

    1. If WANGPENG follows this queue at time 0, WANGPENG has to wait for ai seconds to finish this subject.
    2. As the queue is getting longer, the waiting time will increase bi seconds every second while WANGPENG is not in the queue.
      The input ends with n = 0.
      For all test cases, 0<n≤100000, 0≤ai,bi<231.

    Output

    For each test case, output one line with an integer: the earliest time (counted by seconds) that WANGPENG can finish all exam subjects. Since WANGPENG is always confused by years, just print the seconds mod 365×24×60×60.

    Sample Input

    5 1 2 2 3 3 4 4 5 5 6 0

    Sample Output

    1419

    Hint

    In the Sample Input, WANGPENG just follow the given order. He spends 1 second in the first queue, 5 seconds in the 2th queue, 27 seconds in the 3th queue, 169 seconds in the 4th queue, and 1217 seconds in the 5th queue. So the total time is 1419s. WANGPENG has computed all possible orders in his 120-core-parallel head, and decided that this is the optimal choice.

    题意

    给你n个考试,每个考试会花费ai+bi*t的花费,t表示当前的时间是多少

    题解

    我们首先只考虑两个,排序不同的花费分别为
    a1+a2+a1b2
    a2+a1+a2
    b1
    然后我们随便推一推,可以发现这是一个贪心的策略,我们只要按照a1b2<a2b1这个来进行排序,然后跑一发就好

    代码

    struct node
    {
        LL x;
        LL y;
    };
    bool cmp(node a,node b)
    {
        return a.x*b.y<b.x*a.y;
    }
    const LL mod=365*24*60*60;
    node a[maxn];
    int main()
    {
        int n;
        while(RD(n)!=-1)
        {
            if(n==0)
                break;
            REP_1(i,n)
                RD(a[i].x),RD(a[i].y);
            sort(a+1,a+n+1,cmp);
            LL ans=0;
            REP_1(i,n)
            {
                ans+=a[i].x+ans*a[i].y;
                ans%=mod;
            }
            cout<<ans%mod<<endl;
        }
    }
  • 相关阅读:
    oracleDBA-D4
    oracleDBA-D3
    oracleDBA-D2
    大数据架构学习记录
    UBUNTU 安装最新版 nodejs
    datax 单条记录超过大小限制,当前限制为:67108864
    将anaconda中已存在的虚拟环境增加到jupyterlab
    jupyter 启动python3 内核 总是出现错误 ImportError: cannot import name 'create_prompt_application'
    CDH 本地hadoop支持读写 AWS S3a
    hadoop 集群集成jupyterhub 出现的问题
  • 原文地址:https://www.cnblogs.com/qscqesze/p/4329706.html
Copyright © 2011-2022 走看看